Subject: bug#11339: 24.1.50; read-{buffer,file-name}-completion-ignore-case fails on non-ascii

From: Eli Zaretskii <[email-masked]>
Date: Fri, 01 Nov 2019 22:20:42 +0200

> From: Stefan Kangas <[email-masked]>
> Date: Fri, 01 Nov 2019 20:57:30 +0100
> Cc: [email-masked]
> 
> > 0. emacs -Q
> > 1. M-x customize-option RET read-buffer-completion-ignore-case RET.
> >    Toggle to "on", set for the current session.
> >    M-x customize-option RET read-file-name-completion-ignore-case RET.
> >    Toggle to "on", set for the current session.
> > 2. C-x C-f b TAB => *Completions* buffer contains, as expected: bla bÄh bäh.         
> > 3. Visit files `bla', `bäh' and `bÄh', switch to buffer *scratch* and
> >    repeat step 2, replacing `C-x C-f' with `C-x b' => same results.
> > 4. C-x C-f bä TAB => Emacs completes the input to "bäh".               
> > 5. TAB => Emacs incorrectly reports: "[Sole completion]".                 
> > 6. C-x C-f bÄ TAB => Emacs completes the input to "bÄh".
> > 7. TAB => Emacs incorrectly reports: "[Sole completion]".                 
> > 8. Switch to buffer *scratch* and repeat step 4-7, replacing `C-x C-f'
> >    with `C-x b' => same results.
> 
> I can reproduce this on current master using the simpler recipe:
> 
> 0. emacs -Q
> 1. Evaluate (setq read-buffer-completion-ignore-case t)
> 2. C-x b bäh RET
> 3. C-x b bÄh RET
> 4. C-x b bä TAB TAB
> 
> Result: Completes to "bäh" on first TAB, and on second TAB [Sole
> completion] is displayed in minibuffer.
> 
> Expected result: The "*Completion*" buffer is displayed.

I think your expectations are incorrect in this case.  Try having
buffer names that differ (not in letter-case) in the 3rd letter.

What I see here is entirely expected and reasonable.  I see no bug.